Subject: bug#23615: closed (Re: bug#23615: 25.1.50; Which platforms can safely use getsockopt(,,SO_ERROR,,)?)

From: [email-masked] (GNU bug Tracking System)
Date: Fri, 10 Jun 2016 12:39:02 +0000

Your bug report

#23615: 25.1.50; Which platforms can safely use getsockopt(,,SO_ERROR,,)?

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
23615: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=23615
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#23615: 25.1.50; Which platforms can safely use getsockopt(,,SO_ERROR,,)?
From: Ken Brown <[email-masked]>
To: Paul Eggert <[email-masked]>
Cc: [email-masked]
Date: Fri, 10 Jun 2016 08:38:36 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

I see that you've made the change I suggested, so my test program is no 
longer relevant.  I'm closing the bug.

Ken

Subject: 25.1.50; Which platforms can safely use getsockopt(,,SO_ERROR,,)?
From: Ken Brown <[email-masked]>
To: [email-masked]
Date: Tue, 24 May 2016 20:26:13 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

There are two places in process.c where getsockopt(,,SO_ERROR,,) is
used to check the status of a socket connection attempt.  The first is
at line 3289, where it is done on all platforms except MS Windows.  The
second is at line 5500, where it is done only on GNU/Linux:

#ifdef GNU_LINUX
	      /* getsockopt(,,SO_ERROR,,) is said to hang on some systems.
		 So only use it on systems where it is known to work.  */
	      {
		socklen_t xlen = sizeof (xerrno);
		if (getsockopt (channel, SOL_SOCKET, SO_ERROR, &xerrno, &xlen))
		  xerrno = errno;
	      }
#else
	      {
		struct sockaddr pname;
		socklen_t pnamelen = sizeof (pname);

		/* If connection failed, getpeername will fail.  */
		xerrno = 0;
		if (getpeername (channel, &pname, &pnamelen) < 0)
		  {
		    /* Obtain connect failure code through error slippage.  */
		    char dummy;
		    xerrno = errno;
		    if (errno == ENOTCONN && read (channel, &dummy, 1) < 0)
		      xerrno = errno;
		  }
	      }
#endif

It would be better to use it on as many platforms as possible, since
it's much more likely to give the real reason for a connection failure
than the "error slippage" method.

Ken